﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading.Tasks;

namespace ImageCellBindBooking
{
    public class BookingViewModel : INotifyPropertyChanged
    {
        private List<string> _statusList;
        private List<string> _names;
        private ObservableCollection<Booking> _bookings;

        public List<string> StatusList
        {
            get { return _statusList; }
            set { _statusList = value; }
        }
        public ObservableCollection<Booking> Bookings
        {
            get { 
                return _bookings; 
            }
            set { 
                _bookings = value;
                NotifyPropertyChanged();
            }
        }

        public BookingViewModel()
        {
            _statusList = new List<string>() { "Unknown", "Reserved", "Cancelled" };
            _names = new List<string>() { "Alex", "Charlie", "Thomas", "Erica", "Peter" };
        }

        public ObservableCollection<Booking> GetDataItems()
        {
            _bookings = new ObservableCollection<Booking>();
            Random random = new Random();
            Booking booking;
            for (int i = 0; i < 5; i++)
            {
                booking = new Booking();
                booking.Sno = i+1;
                booking.Name = _names[i];
                booking.Status = _statusList[random.Next() % _statusList.Count];
                Bookings.Add(booking);
            }
            return Bookings;
        }

        public event PropertyChangedEventHandler PropertyChanged;

        private void NotifyPropertyChanged([CallerMemberName] String propertyName = "")
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }
    }
}
